package com.fp.persistence.parmas.soli;

import java.io.Serializable;
import java.lang.reflect.Field;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMBODEGA*/
@Entity(name="TarmBodega")
@Table(name="TARMBODEGA")
public class TarmBodega extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmBodega
*/
@Id
@Column(name="CBODEGA" ,nullable=false, updatable=false)
private Long pk;
@Column(name="CARMA", nullable=true)

/**
* codigo del arma
*/
private String carma;

@Column(name="CCENTROCONTROL", nullable=true)

/**
* Codigo de centro de control de armas,codigo de la bodega donde se encuentra el arma
*/
private String ccentrocontrol;

/**Contructor por defecto*/
public TarmBodega(){
}
/**Contructor de TarmBodega
@param pPk Clave Primaria del entity
*/
public TarmBodega(Long pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmBodega
*/
public static TarmBodega find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmBodega obj = pEntityManager.find(TarmBodega.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmBodega
@return El objeto que referencia a la Clave primaria de TarmBodega
*/
public Long getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmBodega
@param pPk El objeto que referencia a la nueva Clave primaria de TarmBodega
*/
public void setPk(Long pPk){
  pk=pPk;
}
/**Obtiene el valor de carma
@return valor de carma*/
public String getCarma(){
  return carma;
}
/**Fija el valor de carma
@param pCarma nuevo Valor de carma*/
public void setCarma(String pCarma){
  carma=pCarma;
}

/**Obtiene el valor de ccentrocontrol
@return valor de ccentrocontrol*/
public String getCcentrocontrol(){
  return ccentrocontrol;
}
/**Fija el valor de ccentrocontrol
@param pCcentrocontrol nuevo Valor de ccentrocontrol*/
public void setCcentrocontrol(String pCcentrocontrol){
  ccentrocontrol=pCcentrocontrol;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmBodega))return false;
    TarmBodega that = (TarmBodega) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmBodega
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmBodega
*/
public Object createInstance(){
 TarmBodega instance=new TarmBodega();	
 return instance;
}
/**Clona la entidad TarmBodega
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmBodega p=(TarmBodega)this.clone();
  return p;
}
}
